Page MenuHomePhabricator

Technical Collaboration narratives and budget for core work
Closed, ResolvedPublic

Description

WARNING: this is a wild draft; everything may still change.

Core goal: Organized community engagement across all stages of a common product development process

We will keep working on a common product development process documented, registering constructive and productive community engagement in all stages. All WMF Product teams will be encouraged to follow this process and interact with the communities under the terms agreed. Communities will be able to effectively contribute to and influence the planning and prioritization of new features, as well as negotiate how and when these features are deployed to their wikis. We will continue progressing on this goal through continuous improvements agreed with our communities and dev teams.

Project/Initiative 1: Consolidation of a participative product development process

Refine and document systematic approaches for community engagement across the different stages of product development. Involve the communities in the design and the improvement of this process. Inform the communities how to follow and participate in WMF Product projects.

Project/Initiative 2: Community liaison support to WMF Product teams

Direct support provided to WMF Product teams around new initiatives and ongoing complex projects (e.g. VisualEditor, Community Wishlist). Our support focuses on connecting our communities and development teams through their excitement and concerns, helping them to work with each other. We help providing institutional memory, reaching out to volunteers, finding common interests, anticipating potential problems, and recommending ways forward. Discovery, Reading, Editing, and Community Tech will have a community liaison permanently appointed. More liaisons will be available for specific project collaborations.

Milestones/Results/Impact

Please provide milestones/results/impact and describe how they will impact/contribute to the Wikimedia movement and projects and/or the Wikimedia Foundation.

Project/Initiative 1:
Coming soon, we want to hear feedback about the goals & projects first.

Project/Initiative 2:
Coming soon, we want to hear feedback about the goals & projects first.

Key Performance Indicators (KPIs) or Metrics to measure milestones/success of projects/initiatives

Please ensure that these are both qualitative and quantitative. Some departments may have the same metrics as the following 7 Global Metrics identified for the FDC proposals. Others may need to identify their own KPIs or metrics that are appropriate for their objectives. For example a supporting function such as Office Admin, KPIs or metrics may be in the form of Service Level Agreements.

Global Metrics

  1. Number of active editors involved
  2. Number of new registered users
  3. Number of individuals involved
  4. Number of new images/media added to Wikimedia article pages
  5. Number of articles added or improved on Wikimedia projects
  6. Number of bytes added to and/or deleted from Wikimedia projects
  7. Learning question: Did your work increase the motivation of contributors, and how do you know?

Project/Initiative 1:
Number of non-WMF participants involved in every stage of the product development process
Number of new registered individuals participating in the product development process
Percentage of active WMF software projects following the product development process
Number of community-driven software projects following the product development process
Number of community conflicts disrupting or delaying product release plans
Satisfaction survey for participants in the process and power editors

Project/Initiative 2:
Coming soon -- see T124155: Review key performance indicators (KPIs) for Community Liaison and Developer Relations

See also T124420: Technical Collaboration narratives and budget for strategic work

Previous description

The first deadline of the WMF Annual Plan (T124019) is

Wednesday, February 3 - Initial budgets and narratives are due for Core Work
Core work budgets for 2016-17 to include: staffing, travel, consultants, equipment, off sites, etc. needed to support current work and projects and to continue those projects for the coming fiscal year, as appropriate, are completed and sent to Finance.

February 3 for all WMF means we need to have a solid draft by Jan 28, and this means that we need to start the work right now.

While a lot of this work is counting beans looking at this fiscal year's budget, the distinction between core and strategic poses an interesting question: how much time are CL and DevRel putting in core work? For a definition of core, see Tracking core and strategic work.

(snip)

Event Timeline

Qgil created this task.Jan 19 2016, 1:38 PM
Qgil claimed this task.
Qgil raised the priority of this task from to High.
Qgil updated the task description. (Show Details)
Qgil added subscribers: Aklapper, Qgil, DannyH and 2 others.
Elitre added a subscriber: Elitre.Jan 19 2016, 1:59 PM

I wish the distinction was that easy.
In my mind, checking and answering on feedback pages is core; working on the plan for centralization of feedback is strategic.
Addressing feedback about the single edit tab is core; working on plans to bring the SET to the wikis is strategic.
(I'm thinking that our work looks a lot like Sisyphus' one, and that it's at the same time core and strategic: as a colleague put it, it's ultimately about slowly building trust which will then be spent with a sudden action by someone else, and then starting all over again.)

Qgil added a comment.EditedJan 19 2016, 2:20 PM

@Elitre we will probably need to go for a % split, and maybe per product team if we want to be more precise. For instance, maybe in Editing is more 50%-50% whereas in Discovery, Reading, and Special Projects is more 90% strategic - 10% core, and the opposite in Community Tech.

If the idea of the percentages makes sense, then we need to define the %s.

I tend to agree with Erica; that's how I see my work, using plain-English understandings of these words.

However, it terms of the particular definitions being used in the linked page at mw.org, I can see CLs's work to support specific products being entirely classified as core. Support of products is core, because supporting those products is why the team was created and what we would do every day, even if "nothing" was happening. Or, to use the words from the definition, they are "activities required to maintain current level of support and services for our projects."

However, under this definition, the short-term goal of writing up product and design development principles is "strategic", because it's (we hope) a time-bounded project with discrete start and stop points.

I don't see any reason to treat Community Tech differently. Other supported products have done significant work on technical debt, too, and most of them also believe that they are providing long overdue misssing features and dealing with old bugs.

Whatamidoing-WMF added a comment.EditedJan 19 2016, 6:54 PM

In terms of the accounting issue:

As a general rule, if a position is (for example) 60% X and 40% Y, and the person does something that is necessary but not directly X or Y, then you allocate the indirect costs according to the relevant percentage. So if the position's time is 60% core and 40% strategic this quarter, and the staff member attends a meeting on a new policy for employees, then the cost of attending that meeting is allocated as 60% core and 40% strategic.

On the other hand, if the meeting is directly relevant – for example, an event organizer traveling to the event, when you have decided that organizing events is the core activity for that position – then that meeting would get classified as 100% core (or 100% strategic, if the activity is classified as strategic).

Hmmm - there is a CE Dept sprint on Thursday around defining core vs. strategic work.

The team's workflows around interaction with communities can be replicated across all of products: as an example, taking feedback from a product talk page and turning it into actionable feedback in Phabricator. For that reason we've generally defined it as Core.

We will certainly continue defining and refining. :)

Qgil added a comment.Jan 20 2016, 2:47 PM

Let me add some extreme examples:

  • The Discovery team didn't exist. Their creation was mostly "strategic". If then a full time liaison needed to be hired, that FTE was "strategic" as well, not "core".
  • If 100% of CL resources get allocated to core, then that means that we have no resources for strategic work. For instance, no liaisons to work on the design and implementation of product development process. Stepping out of daily tactical work (core) in order to fix underlying problems is strategic, and we need to account for that.

I guess at the end we will need to gather data but make a strategic decision: 50%-50%? 60%-40%? 70%-30%?

IMO, based upon the current definition, the product development process is strategic, and everything else is core.

"Strategic" and "core" aren't inheritable qualities. If we add 50 devs for a strategic project, we also need to add more people to process payroll, but the expansion of the payroll department isn't a strategic initiative merely because they support a strategic initiative. (Also, while "starting Discovery" could be a strategic project, the continued existence of Discovery is not.)

Finally, it's worth remembering the purpose of this particular exercise. The purpose is not to tell you that you can't later change your mind and do X% strategic work instead of the Y% strategic work that you originally estimated. If we declare CLs to be 100% core, and realize later that it's actually only 90%, then that's fine: we'll do what we should do, and we can make a better estimate next year.

Qgil updated the task description. (Show Details)Jan 22 2016, 1:57 PM
Qgil set Security to None.
Qgil added a comment.EditedJan 22 2016, 2:04 PM

Alright, please check the proposal of goal and supporting projects that I just posted in the description of this task.

Basically, most of Community Liaisons time would be placed in Core, indeed. However, this doesn't mean that CLs work continues as it is today during the next fiscal year. The team will keep supporting directly WMF Product teams, but we will find the time and the way to push the product development process, with the idea that collaboration between developer teams and communities will improve with that process.

I'm adding product development process as part of core because it is not a new project in itself, but an improvement over an existing process that we plan to implement step by step. This way the success in our core goal depends on a good balance between current direct support to WMF teams and the new improvements to the product development process, and it will be up to us to put more or less eggs in each basket to better achieve the goal.

Also, this allows to focus our strategic goal in something different, because now the Liaisons-Core part is well covered.

How does this sound?

Qgil updated the task description. (Show Details)Jan 22 2016, 3:02 PM
Qgil updated the task description. (Show Details)Jan 22 2016, 6:33 PM

At a glance, it sounds to me like Project/Initiative 1 is actually strategic (a discrete project that might succeed or might fail, and we'll find out in the future).

Project/Initiative 2 looks like a solid example of a Core activity: important, ongoing, and worth tweaking or re-balancing on occasion (e.g., more for this product, less for that product).

Ok, should we say we're 80-20 now and aiming to... 70-30 in the short term?

Qgil added a comment.Jan 25 2016, 7:40 PM

The WMF template asks for team members involved in core work and team members involved in strategic work, as if they were totally separate groups of people (i.e. if Erica appears in core, Erica cannot appear in strategic). This makes sense from a financial point of view, I asked whether it could be done with percentages for people but (long story short) I'm not counting with changes.

This means that the actual discussion is not about percentages but about names and who (for the sake of the Annual Plan) is listed under core and strategic. We can use our team meetings to clarify this, as we are not going to have this discussion in this task.

Qgil moved this task from Backlog to Doing on the Liaisons-January-2016 board.Jan 26 2016, 7:10 AM
Qgil moved this task from Backlog to Doing on the DevRel-January-2016 board.Jan 26 2016, 6:59 PM
Qgil updated the task description. (Show Details)Jan 27 2016, 3:23 PM

Please check the description updated with the current draft.

Qgil added a comment.Feb 3 2016, 11:10 PM

I have updated the description with the changes made today before the deadline. The main changes are shorter texts and an acknowledgement that our work on the product development process started 6-8 months before the beginning of FY2016-17.

Qgil lowered the priority of this task from High to Normal.Feb 12 2016, 9:06 AM

Lowering priority only to reflect that I'm not working actively on this, but reacting quickly whenever Finance or anybody else has a question or feedback.

Now it's time to push T124420: Technical Collaboration narratives and budget for strategic work

Qgil renamed this task from Community Liaisons and Developer Relations narratives and budget for core work to Technical Collaboration narratives and budget for core work.Feb 12 2016, 10:25 AM
Qgil lowered the priority of this task from Normal to Low.Mar 17 2016, 11:52 AM

I'm lowering the priority of this task only because from now on my role is going to be more reactive than proactive. For more details, see T124019#2129027.

Qgil closed this task as Resolved.Apr 2 2016, 1:11 PM

The result of this task can be seen at https://meta.wikimedia.org/wiki/Wikimedia_Foundation_Annual_Plan/2016-2017/draft#Program_7:_Improve_collaboration_with_communities_in_product_development

The review process has started (and in fact I already replied to one question in the discussion page). The work of responding to feedback during the review process is tracked in the parent task: T124019: Define the Technical Collaboration annual plan FY2016-17.

Resolving.